
-- # import Property

-- Models -----------------------------------------------------------------

Model : Set -> ISet -> Type
Model a a' = (x : a) -> (x' : a') -> Prop

Injective (a : Set)(a' : ISet) : Model a a' -> Prop
Injective {a} {a'} mA = (x : a) -> (y, z : a') -> mA x y /\ mA x z ==> y == z

-- _|_ --------------------------------------------------------------------

"_|_" (a : ISet) : a

data Partial (a : Set) : Set where
  bot : Partial a
  val : a -> Partial a

injPartial (a : Set)(a' : ISet) : (a -> a') -> Partial a -> a'
injPartial i bot      = "_|_"
injPartial i (val x)  = i x

modelPartial (a : Set)(a' : ISet) : Model a a' -> Model (Partial a) a'
modelPartial modelA bot x'	= x' == "_|_"
modelPartial modelA (val x) x'	= modelA x x'

-- Function models --------------------------------------------------------

{-

Logical relation:

f ~ g = forall x y. x ~ y ==> f x ~ g y

Fundamental lemma of logical relations:

any term is in relation with itself?

-}

injFun (a, b : Set) (a', b' : ISet) :
    (i : a -> a') -> (j : b -> b') ->
    (f : a -> b) -> (f' : a' -> b') ->
    Prop
injFun {a} i j f f' = (x : a) -> f' (i x) == j (f x)

infixr 8 |->
(|->) (a, b : Set) (a', b' : ISet) :
    Model a a' -> Model b b' -> Model (a -> b) (a' -> b')
(|->) {a}{_}{a'}{_} mA mB = \f f' -> (x : a) -> (x' : a') -> mA x x' ==> mB (f x) (f' x')

