
data List (a : Set) : Set where
  nil : List a
  (::) : a -> List a -> List a

infixr 10 ::

data Bool : Set where
  false : Bool
  true	: Bool

data Nat : Set where
  zero : Nat
  succ : Nat -> Nat

if (a : Set) : Bool -> a -> a -> a
if false x y  = y
if true x y   = x

length (a : Set) : List a -> Nat
length []     = 0
length (x::xs) = succ (length xs)

insert' (a : Set) : (a -> a -> Bool) -> a -> List a -> List a
insert' (<=) x [] = [x]
insert' (<=) x (y::ys) =
    if (x <= y)
       (x :: y :: ys)
       (y :: insert' (<=) x ys)

sort' (a : Set) : (a -> a -> Bool) -> List a -> List a
sort' (<=) [] = []
sort' (<=) (x::xs) = insert' (<=) x (sort' (<=) xs)

