-- Defines the booleans and some functions over them.
-- Author :: Ulf Norell
-- Created:: 2004-12-06

-- # import Property

-- The booleans -----------------------------------------------------------
data Bool : Set where
  false : Bool
  true  : Bool

-- if ---------------------------------------------------------------------
if (A:Set) : Bool -> A -> A -> A
if true  x y    = x
if false x y    = y

ifD (C : Bool -> Set) : (b:Bool) -> C true -> C false -> C b
ifD true x y    = x
ifD false x y   = y

-- Logical functions ------------------------------------------------------
infixr 6 &&
infixr 5 ||

(&&) : Bool -> Bool -> Bool
true && y   = y
false && _  = false

(||) : Bool -> Bool -> Bool
true || _ = true
false || y = y

not : Bool -> Bool
not true = false
not false = true

-- Lifting to Prop --------------------------------------------------------
Holds : Bool -> Prop
Holds true  = True
Holds false = False

