
-- # import Ord

-- Commutativity of max
propMaxCommute :
    (A : Set) -> (ordA : Ord A) ->
    (x, y : A) -> Holds (ordA.equ.eq (max ordA x y) (max ordA y x))
propMaxCommute A ordA x y =
    propIf A (\z -> Holds (ordA.equ.eq z (if (ordA.leq y x) x y)))
      (ordA.leq x y) y x
      (\p -> propIf A (\z -> Holds (ordA.equ.eq y z))
        (ordA.leq y x) x y
        (\q -> ordA.proofs.antisym y x q p)
        (\q -> ordA.equ.proofs.refl y)
      )
      (\p -> propIf A (\z -> Holds (ordA.equ.eq x z))
        (ordA.leq y x) x y
        (\q -> ordA.equ.proofs.refl x)
        (\q -> ordA.proofs.antisym x y
                  fol-plugin(q, ordA.proofs.total, propHoldsNot)
                  fol-plugin(p, ordA.proofs.total, propHoldsNot)
        )
      )

-- Commutativity of min
propMinCommute :
    (A : Set) -> (ordA : Ord A) ->
    (x, y : A) -> Holds (ordA.equ.eq (min ordA x y) (min ordA y x))
propMinCommute A ordA x y = propMaxCommute A (invertOrd ordA) x y

-- x <= max x y
propMaxLeq :
    (A : Set) -> (ordA : Ord A) ->
    (x, y : A) -> Holds (ordA.leq x (max ordA x y))
propMaxLeq A ordA x y =
    propIf A (\z -> Holds (ordA.leq x z))
      (ordA.leq x y) y x
      (\p -> p)
      (\_ -> ordA.proofs.refl x x (ordA.equ.proofs.refl x))

-- min x y <= x
propMinLeq :
    (A : Set) -> (ordA : Ord A) ->
    (x, y : A) -> Holds (ordA.leq (min ordA x y) x)
propMinLeq A ordA x y = propMaxLeq A (invertOrd ordA) x y

-- n <= m ==> m == max n m
propMaxEq :
    (A : Set) -> (ordA : Ord A) ->
    (x, y : A) -> Holds (ordA.leq x y) ->
    y == max ordA x y
propMaxEq A ordA x y = fol-plugin(propHoldsTrueE, if)

propMinEq :
    (A : Set) -> (ordA : Ord A) ->
    (x, y : A) -> Holds (ordA.leq y x) ->
    y == min ordA x y
propMinEq A ordA x y = fol-plugin(propHoldsTrueE, if)

