
module TypeChecker.Universes where

import Syntax.Internal
import TypeChecker.UnfoldConstants

instance Eq SortValue where
    VSUniv u1 == VSUniv u2  = u1 == u2
    VSProp == VSProp	    = True
    _ == _		    = False

instance Ord SortValue where
    max (VSUniv u1) (VSUniv u2)	= VSUniv $ max u1 u2
    max (VSUniv 0) VSProp	= VSUniv 1
    max VSProp (VSUniv 0)	= VSUniv 1
    max VSProp s		= s
    max s VSProp		= s

    s1 <= s2	= max s1 s2 == s2

-- | Check if two sorts are equal.

-- | Extract the sort from a value we know to be a sort.
getSortValue :: Value -> SortValue
getSortValue v = s
    where VSort s = unfoldConstants v

