-- Normalizing If-Expressions
-- Author:: Andreas Abel
-- Created:: 2004-12-07

-- # import Bool

-- Fix some set of variables and some valuation

A : Set
f : A -> Bool

-- If expressions over variables in some set A

data IfExp : Set where
    Bit : Bool -> IfExp
    Var : A -> IfExp
    If  : IfExp -> IfExp -> IfExp -> IfExp

-- Semantics

eval : (A -> Bool) -> (IfExp -> Bool)
eval (Bit b) = b
eval (Var a) = f a
eval (If c t e) = if Bool (eval c) (eval t) (eval e)
