
data Nat : Type where
  zero	: Nat
  succ	: Nat -> Nat

data Zero : Type where
data Succ (n : Type) : Type where
  fz  : Succ n
  fs  : n -> Succ n

Fin : Nat -> Type
Fin 0	      = Zero
Fin (succ n)  = Succ (Fin n)

finElim :
	(n : Nat) -> (x : Fin n) ->
	(P : (m : Nat) -> Fin m -> Type) ->
	((m : Nat) -> P (succ m) fz) ->
	((m : Nat) -> (y : Fin m) -> P m y -> P (succ m) (fs y)) ->
	P n x
--finCase 0 .
finElim (succ n) fz P z s     = z n
finElim (succ n) (fs x) P z s = s n x (finElim n x P z s)

finCase :
	(n : Nat) -> (x : Fin n) ->
	(P : (m : Nat) -> Fin m -> Type) ->
	((m : Nat) -> P (succ m) fz) ->
	((m : Nat) -> (y : Fin m) -> P (succ m) (fs y)) ->
	P n x
finCase n x P z s =
  finElim n x {P} of
    (succ m) fz	      -> z m
    (succ m) (fs x')  -> \_ -> s m x'

example : (n : Nat) -> (i, j : Fin n) -> Fin n
example n i j =
  ( finCase n j {\n j -> (i : Fin n) -> Fin n} of
      (succ m) fz	-> \i -> let _i = debug-plugin(i) in ?
      (succ m) (fs j')  -> \i -> let _i = debug-plugin(i) in ?
  ) i

