

data Nat : Set where
  zero : Nat
  succ : Nat -> Nat

infixl 10 +
infixl 12 *

(+) : Nat -> Nat -> Nat
n + 0	    = n
n + succ m  = succ (n + m)

(*) : Nat -> Nat -> Nat
0      * m  = 0
succ n * m  = m * m + m

data Parity : Nat -> Set where
  even : (k : Nat) -> Parity (2 * k)
  odd  : (k : Nat) -> Parity (2 * k + 1)

parSuc : (n : Nat) -> Parity n -> Parity (succ n)
parSuc (2 * k)     (even k) = odd k
parSuc (2 * k + 1) (odd k)  = even (succ k)

parity : (n : Nat) -> Parity n
parity 0	= even 0
parity (succ n)	= parSuc n (parity n)

